// WidcommSppServer.cpp: implementation of the CWidcommSppServer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "wcbts.h"
#include "WidcommSppServer.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CWidcommSppServer::CWidcommSppServer()
:	m_sppServerCallback	(NULL),
	m_hWnd				(NULL),
	m_nMsg				(0)
{

}

CWidcommSppServer::~CWidcommSppServer()
{

}


void CWidcommSppServer::OnServerStateChange(BD_ADDR bda, DEV_CLASS devClass, BD_NAME bdName, short com_port, SPP_STATE_CODE state)
{
	BLUETOOTH_SPP_INFO*		pBtSppInfo;

	//
	// Allocate the device info structure on the local heap
	//
	pBtSppInfo = (BLUETOOTH_SPP_INFO*)LocalAlloc(LPTR, sizeof(BLUETOOTH_SPP_INFO));

	if(!pBtSppInfo)
		return;

	// Set the device address
	pBtSppInfo->Address.ullLong =	(ULONGLONG)bda[0] << 40 |
									(ULONGLONG)bda[1] << 32 |
									(ULONGLONG)bda[2] << 24 |
									(ULONGLONG)bda[3] << 16 |
									(ULONGLONG)bda[4] <<  8 |
									(ULONGLONG)bda[5];

	//memcpy(pBtDevInfo->Address.rgBytes, bda, sizeof(UINT8) * BD_ADDR_LEN);

	// Set the device class
	pBtSppInfo->ulClassofDevice = ((ULONG)devClass[0] << 16) + ((ULONG)devClass[1] << 8) + devClass[2];

	MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, (const char*)bdName, BD_NAME_LEN, pBtSppInfo->szName, BD_NAME_LEN);

	if(m_sppServerCallback != NULL)
		m_sppServerCallback(pBtSppInfo);

	//
	// Here, we can also use the asynchronous PostMessage because the
	// device info structures are allocated on the heap and are released
	// by the consuming applciation
	//
	if(m_hWnd != NULL)
		SendMessage(m_hWnd, m_nMsg, 0, (LPARAM)pBtSppInfo);
}
