// WidcommStack.h: interface for the CWidcommStack class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WIDCOMMSTACK_H__DDBA9F5E_A7B1_4777_8E39_05C0C0D70003__INCLUDED_)
#define AFX_WIDCOMMSTACK_H__DDBA9F5E_A7B1_4777_8E39_05C0C0D70003__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


struct SdpRecs
{
	int					m_nSdpRecs;
	CSdpDiscoveryRec	m_pSdpRecs[32];
};


class CWidcommStack : public CBtIf
{
public:
	CWidcommStack();
	virtual ~CWidcommStack();

    virtual void OnDeviceResponded(BD_ADDR bda, DEV_CLASS devClass, BD_NAME bdName, BOOL bConnected);
    virtual void OnDiscoveryComplete();
	virtual void OnInquiryComplete(BOOL bSuccess, short nResponses);

	void	NotifyWindow(HWND hWnd, UINT nMsg) { m_hWnd = hWnd; m_nMsg = nMsg; }

	int					GetSdpRecordCount	();
	CSdpDiscoveryRec*	GetSdpRecord		(int iRecord);

	void	SetBdAddr	(BD_ADDR bdAddr)	{ memcpy(m_bdAddr, bdAddr, sizeof(BD_ADDR));	}

private:
	DeviceRespondedCallback		m_deviceResponded;
	DiscoveryCompleteCallback	m_discoveryComplete;
	InquiryCompleteCallback		m_inquiryComplete;
	HWND						m_hWnd;
	UINT						m_nMsg;
	UINT8						m_bdAddr[BD_ADDR_LEN];
};

#endif // !defined(AFX_WIDCOMMSTACK_H__DDBA9F5E_A7B1_4777_8E39_05C0C0D70003__INCLUDED_)
